APIs in Category: qos | Cluster-Mode API version 1.20

qos-policy-group-create qos-policy-group-delete qos-policy-group-delete-iter qos-policy-group-get qos-policy-group-get-iter qos-policy-group-modify qos-policy-group-modify-iter qos-policy-group-rename qos-settings-archived-workload-get qos-settings-archived-workload-modify qos-settings-control-get qos-settings-control-modify qos-settings-read-ahead-create qos-settings-read-ahead-destroy qos-settings-read-ahead-destroy-iter qos-settings-read-ahead-get qos-settings-read-ahead-get-iter qos-settings-read-ahead-modify qos-settings-read-ahead-modify-iter qos-test-smf-zapi-error qos-workload-delete qos-workload-delete-iter qos-workload-get qos-workload-get-iter qos-workload-modify qos-workload-modify-iter | These APIs enable management of Quality of Service (QoS) workloads and policy groups. QoS allows users to use a policy group to control a set of storage objects known as workloads - LUNs, volumes, files, or Vservers. Policy groups define measurable service level objectives (SLOs) that apply to the storage objects with which the policy group is associated. A typical user of these APIs will first create a policy group with the qos-policy-group-create API. The caller must specify a unique name for the new policy group. The UUID of the newly create policy group is returned by this API, and should be used to identify the policy group in all subsequent operations. After a policy group is created, one can use a storage object API to apply the policy group to the storage object. For example, the vserver-create API or the vserver-modify API can be used to apply the policy group to the Vserver when the qos-policy-group parameter is given.

NetApp Manage ONTAP

qos-policy-group-create | [top]

> Create a policy group. A unique name must be provided for the new policy group. A QoS Policy group defines measurable Service Level Objectives (SLOs) that apply to the storage object with which the policy group is associated.

> Input Name | Range | Type | Description
> max-throughput |  | qos-tput optional | Maximum throughput defined by this policy. It is specified in terms of IOPS or MB/s, and the range is zero to infinity. The values entered here are case-insensitive, and the units are base ten. There should be no space between the number and the units. The default value for max-throughput is infinity. The default unit is IOPS. Two reserved keywords, 'none' and 'INF', are available for the situation that requires removal of a value, and the situation that needs to specify the maximum available value. Examples of valid specifications are: 100B/s, 10KB/s, 1gb/s, 500MB/s, 1tb/s, and 100iops.
> policy-group |  | string | Name of the policy group. Policy group names must be unique and are restricted to 128 alphanumeric characters, '-', and '_', and must start with an alphanumeric character (a-z, A-Z, or 0-9).
> return-record |  | boolean optional | If set to true, returns the qos-policy-group on successful creation. Default: false
> vserver |  | vserver-name | The Data Vserver to which the policy group belongs.
> Output Name | Range | Type | Description
> result |  | qos-policy-group-info optional | The qos-policy-group created (keys or the entire object if requested)

> Errno | Description
> EINTERNALERROR |  |

qos-policy-group-delete | [top]

> Delete single policy group. The default policy group may not be deleted. The policy group may not be attached to any workloads. Only user defined policy groups may be deleted.

> Input Name | Range | Type | Description
> policy-group |  | string | Name of the policy group. Policy group names must be unique and are restricted to 128 alphanumeric characters, '-', and '_', and must start with an alphanumeric character (a-z, A-Z, or 0-9).

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-policy-group-delete-iter | [top]

> Delete multiple policy groups.

> Input Name | Range | Type | Description
> continue-on-failure |  | boolean optional | This input element is useful when multiple qos-policy-group objects match a given query. If set to true, the API will continue deleting the next matching qos-policy-group even when the deletion of a previous qos-policy-group fails. If set to false, the API will return on the first failure. Default: false
> max-failure-count | [1..2^32-1] | integer optional | When allowing failures ('continue-on-failure' is set to true), then this input element may be provided to limit the number of failed deletions before the server gives up and returns. If set, the API will continue deleting the next matching qos-policy-group even when the deletion of a previous matching qos-policy-group fails, and do so until the total number of objects failed to be deleted reaches the maximum specified. If set to the maximum or not provided, then there will be no limit on the number of failed deletions. Only applicable if 'continue-on-failure' is set to true. Default: 2^32-1
> max-records | [1..2^32-1] | integer optional | The maximum number of qos-policy-group objects to delete in this call. Default: 20
> query |  | qos-policy-group-info | If deleting a specific qos-policy-group, this input element must specify all keys. If deleting multiple qos-policy-group objects based on query, this input element must specify a query.
> return-failure-list |  | boolean optional | If set to true, the API will return the list of qos-policy-group objects (just keys) that were not deleted due to some error. If set to false, the list of qos-policy-group objects not deleted will not be returned. Default: true
> return-success-list |  | boolean optional | If set to true, the API will return the list of qos-policy-group objects (just keys) that were successfully deleted. If set to false, the list of qos-policy-group objects deleted will not be returned. Default: true
> tag |  | string optional | Specify the tag from the last call. It is usually not specified for the first call. For subsequent calls, copy values from the next-tag obtained from the previous call.
> Output Name | Range | Type | Description
> failure-list |  | qos-policy-group-delete-iter-info[] optional | Information about qos-policy-group objects that were not deleted due to some error. This element will be returned only if input element 'return-failure-list' is true.
> next-tag |  | string optional | Tag for the next call. Not present when there are no more matching qos-policy-group objects to be deleted.
> num-failed | [0..2^32-1] | integer optional | Number of qos-policy-group objects that matched the query, but were not deleted due to some error.
> num-succeeded | [0..2^32-1] | integer optional | The number of qos-policy-group objects that matched the query and were successfully deleted.
> success-list |  | qos-policy-group-delete-iter-info[] optional | The qos-policy-group objects that were successfully deleted. This element will be returned only if input element 'return-success-list' is true

> Errno | Description
> EINTERNALERROR |  |

qos-policy-group-get | [top]

> Get the attributes of a policy group.

> Input Name | Range | Type | Description
> desired-attributes |  | qos-policy-group-info optional | Specify the attributes that should be returned. If not present, all attributes for which information is available will be returned. If present, only the desired attributes for which information is available will be returned.
> policy-group |  | string | Name of the policy group. Policy group names must be unique and are restricted to 128 alphanumeric characters, '-', and '_', and must start with an alphanumeric character (a-z, A-Z, or 0-9).
> Output Name | Range | Type | Description
> attributes |  | qos-policy-group-info | The attributes of the qos-policy-group.

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-policy-group-get-iter | [top]

> Iterate over list of policy groups.

> Input Name | Range | Type | Description
> desired-attributes |  | qos-policy-group-info optional | Specify the attributes that should be returned. If not present, all attributes for which information is available will be returned. If present, only the desired attributes for which information is available will be returned.
> max-records | [1..2^32-1] | integer optional | The maximum number of records to return in this call. Default: 20
> query |  | qos-policy-group-info optional | A query that specifies which objects to return. A query could be specified on any number of attributes in the qos-policy-group object. All qos-policy-group objects matching this query up to 'max-records' will be returned.
> tag |  | string optional | Specify the tag from the last call. It is usually not specified for the first call. For subsequent calls, copy values from the 'next-tag' obtained from the previous call.
> Output Name | Range | Type | Description
> attributes-list |  | qos-policy-group-info[] optional | The list of attributes of qos-policy-group objects.
> next-tag |  | string optional | Tag for the next call. Not present when there are no more qos-policy-group objects to return.
> num-records | [0..2^32-1] | integer | The number of records returned in this call.

> Errno | Description
> EINTERNALERROR |  |

qos-policy-group-modify | [top]

> Modify an existing policy group.

> Input Name | Range | Type | Description
> max-throughput |  | qos-tput optional | Maximum throughput defined by this policy. It is specified in terms of IOPS or MB/s, and the range is zero to infinity. The values entered here are case-insensitive, and the units are base ten. There should be no space between the number and the units. The default value for max-throughput is infinity. The default unit is IOPS. Two reserved keywords, 'none' and 'INF', are available for the situation that requires removal of a value, and the situation that needs to specify the maximum available value. Examples of valid specifications are: 100B/s, 10KB/s, 1gb/s, 500MB/s, 1tb/s, and 100iops.
> policy-group |  | string | Name of the policy group. Policy group names must be unique and are restricted to 128 alphanumeric characters, '-', and '_', and must start with an alphanumeric character (a-z, A-Z, or 0-9).

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-policy-group-modify-iter | [top]

> Modify multiple policy groups

> Input Name | Range | Type | Description
> attributes |  | qos-policy-group-info | Specify at least one modifiable element. Do not specify any other element.
> continue-on-failure |  | boolean optional | This input element is useful when multiple qos-policy-group objects match a given query. If set to true, the API will continue modifying the next matching qos-policy-group even when modification of a previous qos-policy-group fails. If set to false, the API will return on the first failure. Default: false
> max-failure-count | [1..2^32-1] | integer optional | When allowing failures ('continue-on-failure' is set to true), then this input element may be provided to limit the number of failed modify operations before the server gives up and returns. If set, the API will continue modifying the next matching qos-policy-group even when the modification of a previous matching qos-policy-group fails, and do so until the total number of objects failed to be modified reaches the maximum specified. If set to the maximum or not provided, then there will be no limit on the number of failed modify operations. Only applicable if 'continue-on-failure' is set to true. Default: 2^32-1
> max-records | [1..2^32-1] | integer optional | The maximum number of objects to be modified in this call. Default: 20
> query |  | qos-policy-group-info | If modifying a specific qos-policy-group, this input element must specify all keys. If modifying qos-policy-group objects based on query, this input element must specify a query.
> return-failure-list |  | boolean optional | If set to true, the API will return the list of qos-policy-group objects (just keys) that were not modified due to some error. If set to false, the list of qos-policy-group objects not modified will not be returned. Default: true
> return-success-list |  | boolean optional | If set to true, the API will return the list of qos-policy-group objects (just keys) that were successfully updated. If set to false, the list of qos-policy-group objects modified will not be returned. Default: true
> tag |  | string optional | Specify the tag from the last call. It is usually not specified for the first call. For subsequent calls, copy values from the 'next-tag' obtained from the previous call.
> Output Name | Range | Type | Description
> failure-list |  | qos-policy-group-modify-iter-info[] optional | Information about qos-policy-group objects that were not modified due to some error. This element will be returned only if input element 'return-failure-list' is true.
> next-tag |  | string optional | Tag for the next call. Not present when there are no more matching qos-policy-group objects to be modified.
> num-failed | [0..2^32-1] | integer optional | Number of qos-policy-group objects that matched the query, but were not modified due to some error.
> num-succeeded | [0..2^32-1] | integer optional | The number of qos-policy-group objects that matched the query and were successfully updated.
> success-list |  | qos-policy-group-modify-iter-info[] optional | The qos-policy-group objects that were successfully updated. This element will be returned only if input element 'return-success-list' is true

> Errno | Description
> EINTERNALERROR |  |

qos-policy-group-rename | [top]

> Rename a QoS Policy Group

> Input Name | Range | Type | Description
> new-name |  | string | New Policy Group Name
> policy-group-name |  | string | Name of the policy group. Policy group names must be unique and are restricted to 128 alphanumeric characters, '-', and '_', and must start with an alphanumeric character (a-z, A-Z, or 0-9).

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-settings-archived-workload-get | [top]

> Get the cluster-wide QoS workload archival settings.

> Input Name | Range | Type | Description
> desired-attributes |  | qos-settings-archived-workload-info optional | Specify the attributes that should be returned. If not present, all attributes for which information is available will be returned. If present, only the desired attributes for which information is available will be returned.
> Output Name | Range | Type | Description
> attributes |  | qos-settings-archived-workload-info | The attributes of the qos-settings-archived-workload.

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-settings-archived-workload-modify | [top]

> Modify the cluster-wide QoS workload archival settings.

> Input Name | Range | Type | Description
> max-workloads | [0..15000] | integer optional | Maximum Number of Workloads to be Archived

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-settings-control-get | [top]

> Get the cluster-wide QoS control settings.

> Input Name | Range | Type | Description
> desired-attributes |  | qos-settings-control-info optional | Specify the attributes that should be returned. If not present, all attributes for which information is available will be returned. If present, only the desired attributes for which information is available will be returned.
> Output Name | Range | Type | Description
> attributes |  | qos-settings-control-info | The attributes of the qos-settings-control.

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-settings-control-modify | [top]

> Modify the existing cluster-wide QoS control settings.

> Input Name | Range | Type | Description
> enforcement |  | boolean optional | Cluster-wide QoS enforcement
> ratebucket-rebalance |  | boolean optional | Manage QoS ratebucket budgets across the cluster

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-settings-read-ahead-create | [top]

> Create a new read-ahead setting. A unique name must be provided for the new read-ahead setting. If the 'default' field is set to true, these become the default read-ahead settings for settings that don't otherwise name read-ahead settings. Unless creating a new default, creating read-ahead settings should usually be assigned to an existing QoS setting.

> Input Name | Range | Type | Description
> align-blocks | [8..256] | integer optional | Block alignment
> default |  | boolean optional | Specifies whether this is the default readahead setting
> disk-response-factor | [1..10] | integer optional | Disk response time factor
> disk-response-weight | [0..100] | integer optional | Weight for disk response time aging (%)
> early-count | [0..1024] | integer optional | Number of IO operations cautiously predicted
> force-dump |  | boolean optional | Force DUMP-style readahead
> force-full |  | boolean optional | Force full-file readahead
> force-none |  | boolean optional | Disable readahead
> interarrival-weight | [0..100] | integer optional | Weight for interarrival time aging (%)
> jitter | [0..100] | integer optional | Threshold for detecting jitter (%)
> max-blocks | [64..1024] | integer optional | Maximum blocks to speculate
> max-deadline | [100000..5000000] | integer optional | Maximum deadline Offset (ms)
> max-disk-response-time | [100..50000] | integer optional | Maximum disk response time (ms)
> max-gap | [512..4096] | integer optional | Maximum speculative blocks outstanding
> max-range | [1024..40960] | integer optional | Maximum range used when aging streams (Blocks)
> max-retire-time | [10000..10000000] | integer optional | Maximum Time Before a Stream is Retired (us)
> metadata-blocks | [0..2048] | integer optional | Minimum blocks for which metadata is predicted
> min-blocks | [64..1024] | integer optional | Minimum blocks to speculate
> min-disk-response-time | [100..50000] | integer optional | Minimum disk response time (ms)
> min-range | [1024..40960] | integer optional | Minimum range used when aging streams (Blocks)
> min-retire-time | [10000..10000000] | integer optional | Minimum Time Before a Stream is Retired (us)
> overshoot | [0..500] | integer optional | Allowable overshoot (%)
> read-ahead-class |  | qos-class optional | Readahead setting class Possible values: "preset" - Preset, "user_defined" - User Defined, "system_defined" - System Defined
> read-ahead-setting-name |  | string | Name of QoS Readahead Setting.
> return-record |  | boolean optional | If set to true, returns the qos-settings-read-ahead on successful creation. Default: false
> smallfile-blocks | [0..128] | integer optional | Maximum blocks for small-file handling
> use-async |  | boolean optional | Use asynchronous speculation
> use-feedback |  | boolean optional | Provide cache-miss feedback
> use-histogram |  | boolean optional | Use Histogram-based predictions
> use-timing |  | boolean optional | Use timing algorithms
> Output Name | Range | Type | Description
> result |  | qos-settings-read-ahead-info optional | The qos-settings-read-ahead created (keys or the entire object if requested)

> Errno | Description
> EINTERNALERROR |  |

qos-settings-read-ahead-destroy | [top]

> Destroy single read-ahead setting. The default setting may not be destroyed. The setting may not be attached to any workloads. Only user defined settings may be destroyed.

> Input Name | Range | Type | Description
> read-ahead-setting-name |  | string | Name of QoS Readahead Setting.

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-settings-read-ahead-destroy-iter | [top]

> Destroy multiple read-ahead settings.

> Input Name | Range | Type | Description
> continue-on-failure |  | boolean optional | This input element is useful when multiple qos-settings-read-ahead objects match a given query. If set to true, the API will continue deleting the next matching qos-settings-read-ahead even when the deletion of a previous qos-settings-read-ahead fails. If set to false, the API will return on the first failure. Default: false
> max-failure-count | [1..2^32-1] | integer optional | When allowing failures ('continue-on-failure' is set to true), then this input element may be provided to limit the number of failed deletions before the server gives up and returns. If set, the API will continue deleting the next matching qos-settings-read-ahead even when the deletion of a previous matching qos-settings-read-ahead fails, and do so until the total number of objects failed to be deleted reaches the maximum specified. If set to the maximum or not provided, then there will be no limit on the number of failed deletions. Only applicable if 'continue-on-failure' is set to true. Default: 2^32-1
> max-records | [1..2^32-1] | integer optional | The maximum number of qos-settings-read-ahead objects to delete in this call. Default: 20
> query |  | qos-settings-read-ahead-info | If deleting a specific qos-settings-read-ahead, this input element must specify all keys. If deleting multiple qos-settings-read-ahead objects based on query, this input element must specify a query.
> return-failure-list |  | boolean optional | If set to true, the API will return the list of qos-settings-read-ahead objects (just keys) that were not deleted due to some error. If set to false, the list of qos-settings-read-ahead objects not deleted will not be returned. Default: true
> return-success-list |  | boolean optional | If set to true, the API will return the list of qos-settings-read-ahead objects (just keys) that were successfully deleted. If set to false, the list of qos-settings-read-ahead objects deleted will not be returned. Default: true
> tag |  | string optional | Specify the tag from the last call. It is usually not specified for the first call. For subsequent calls, copy values from the next-tag obtained from the previous call.
> Output Name | Range | Type | Description
> failure-list |  | qos-settings-read-ahead-destroy-iter-info[] optional | Information about qos-settings-read-ahead objects that were not deleted due to some error. This element will be returned only if input element 'return-failure-list' is true.
> next-tag |  | string optional | Tag for the next call. Not present when there are no more matching qos-settings-read-ahead objects to be deleted.
> num-failed | [0..2^32-1] | integer optional | Number of qos-settings-read-ahead objects that matched the query, but were not deleted due to some error.
> num-succeeded | [0..2^32-1] | integer optional | The number of qos-settings-read-ahead objects that matched the query and were successfully deleted.
> success-list |  | qos-settings-read-ahead-destroy-iter-info[] optional | The qos-settings-read-ahead objects that were successfully deleted. This element will be returned only if input element 'return-success-list' is true

> Errno | Description
> EINTERNALERROR |  |

qos-settings-read-ahead-get | [top]

> Get the attributes of a read-ahead setting.

> Input Name | Range | Type | Description
> desired-attributes |  | qos-settings-read-ahead-info optional | Specify the attributes that should be returned. If not present, all attributes for which information is available will be returned. If present, only the desired attributes for which information is available will be returned.
> read-ahead-setting-name |  | string | Name of QoS Readahead Setting.
> Output Name | Range | Type | Description
> attributes |  | qos-settings-read-ahead-info | The attributes of the qos-settings-read-ahead.

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-settings-read-ahead-get-iter | [top]

> Iterate over list of read-ahead settings.

> Input Name | Range | Type | Description
> desired-attributes |  | qos-settings-read-ahead-info optional | Specify the attributes that should be returned. If not present, all attributes for which information is available will be returned. If present, only the desired attributes for which information is available will be returned.
> max-records | [1..2^32-1] | integer optional | The maximum number of records to return in this call. Default: 20
> query |  | qos-settings-read-ahead-info optional | A query that specifies which objects to return. A query could be specified on any number of attributes in the qos-settings-read-ahead object. All qos-settings-read-ahead objects matching this query up to 'max-records' will be returned.
> tag |  | string optional | Specify the tag from the last call. It is usually not specified for the first call. For subsequent calls, copy values from the 'next-tag' obtained from the previous call.
> Output Name | Range | Type | Description
> attributes-list |  | qos-settings-read-ahead-info[] optional | The list of attributes of qos-settings-read-ahead objects.
> next-tag |  | string optional | Tag for the next call. Not present when there are no more qos-settings-read-ahead objects to return.
> num-records | [0..2^32-1] | integer | The number of records returned in this call.

> Errno | Description
> EINTERNALERROR |  |

qos-settings-read-ahead-modify | [top]

> Modify an existing read-ahead setting.

> Input Name | Range | Type | Description
> align-blocks | [8..256] | integer optional | Block alignment
> default |  | boolean optional | Specifies whether this is the default readahead setting
> disk-response-factor | [1..10] | integer optional | Disk response time factor
> disk-response-weight | [0..100] | integer optional | Weight for disk response time aging (%)
> early-count | [0..1024] | integer optional | Number of IO operations cautiously predicted
> force-dump |  | boolean optional | Force DUMP-style readahead
> force-full |  | boolean optional | Force full-file readahead
> force-none |  | boolean optional | Disable readahead
> interarrival-weight | [0..100] | integer optional | Weight for interarrival time aging (%)
> jitter | [0..100] | integer optional | Threshold for detecting jitter (%)
> max-blocks | [64..1024] | integer optional | Maximum blocks to speculate
> max-deadline | [100000..5000000] | integer optional | Maximum deadline Offset (ms)
> max-disk-response-time | [100..50000] | integer optional | Maximum disk response time (ms)
> max-gap | [512..4096] | integer optional | Maximum speculative blocks outstanding
> max-range | [1024..40960] | integer optional | Maximum range used when aging streams (Blocks)
> max-retire-time | [10000..10000000] | integer optional | Maximum Time Before a Stream is Retired (us)
> metadata-blocks | [0..2048] | integer optional | Minimum blocks for which metadata is predicted
> min-blocks | [64..1024] | integer optional | Minimum blocks to speculate
> min-disk-response-time | [100..50000] | integer optional | Minimum disk response time (ms)
> min-range | [1024..40960] | integer optional | Minimum range used when aging streams (Blocks)
> min-retire-time | [10000..10000000] | integer optional | Minimum Time Before a Stream is Retired (us)
> overshoot | [0..500] | integer optional | Allowable overshoot (%)
> read-ahead-setting-name |  | string | Name of QoS Readahead Setting.
> smallfile-blocks | [0..128] | integer optional | Maximum blocks for small-file handling
> use-async |  | boolean optional | Use asynchronous speculation
> use-feedback |  | boolean optional | Provide cache-miss feedback
> use-histogram |  | boolean optional | Use Histogram-based predictions
> use-timing |  | boolean optional | Use timing algorithms

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-settings-read-ahead-modify-iter | [top]

> Modify multiple read-ahead settings

> Input Name | Range | Type | Description
> attributes |  | qos-settings-read-ahead-info | Specify at least one modifiable element. Do not specify any other element.
> continue-on-failure |  | boolean optional | This input element is useful when multiple qos-settings-read-ahead objects match a given query. If set to true, the API will continue modifying the next matching qos-settings-read-ahead even when modification of a previous qos-settings-read-ahead fails. If set to false, the API will return on the first failure. Default: false
> max-failure-count | [1..2^32-1] | integer optional | When allowing failures ('continue-on-failure' is set to true), then this input element may be provided to limit the number of failed modify operations before the server gives up and returns. If set, the API will continue modifying the next matching qos-settings-read-ahead even when the modification of a previous matching qos-settings-read-ahead fails, and do so until the total number of objects failed to be modified reaches the maximum specified. If set to the maximum or not provided, then there will be no limit on the number of failed modify operations. Only applicable if 'continue-on-failure' is set to true. Default: 2^32-1
> max-records | [1..2^32-1] | integer optional | The maximum number of objects to be modified in this call. Default: 20
> query |  | qos-settings-read-ahead-info | If modifying a specific qos-settings-read-ahead, this input element must specify all keys. If modifying qos-settings-read-ahead objects based on query, this input element must specify a query.
> return-failure-list |  | boolean optional | If set to true, the API will return the list of qos-settings-read-ahead objects (just keys) that were not modified due to some error. If set to false, the list of qos-settings-read-ahead objects not modified will not be returned. Default: true
> return-success-list |  | boolean optional | If set to true, the API will return the list of qos-settings-read-ahead objects (just keys) that were successfully updated. If set to false, the list of qos-settings-read-ahead objects modified will not be returned. Default: true
> tag |  | string optional | Specify the tag from the last call. It is usually not specified for the first call. For subsequent calls, copy values from the 'next-tag' obtained from the previous call.
> Output Name | Range | Type | Description
> failure-list |  | qos-settings-read-ahead-modify-iter-info[] optional | Information about qos-settings-read-ahead objects that were not modified due to some error. This element will be returned only if input element 'return-failure-list' is true.
> next-tag |  | string optional | Tag for the next call. Not present when there are no more matching qos-settings-read-ahead objects to be modified.
> num-failed | [0..2^32-1] | integer optional | Number of qos-settings-read-ahead objects that matched the query, but were not modified due to some error.
> num-succeeded | [0..2^32-1] | integer optional | The number of qos-settings-read-ahead objects that matched the query and were successfully updated.
> success-list |  | qos-settings-read-ahead-modify-iter-info[] optional | The qos-settings-read-ahead objects that were successfully updated. This element will be returned only if input element 'return-success-list' is true

> Errno | Description
> EINTERNALERROR |  |

qos-test-smf-zapi-error | [top]

> Returns SMF error with ZAPI error codes

> Input Name | Range | Type | Description
> error-op-code | [0..2^32-1] | integer | OP code of code to display

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-workload-delete | [top]

> Delete a single workload. Only user defined workloads may be deleted.

> Input Name | Range | Type | Description
> workload-name |  | string | User visible name of QoS workload.

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-workload-delete-iter | [top]

> Delete multiple workloads. Only user defined workloads may be deleted.

> Input Name | Range | Type | Description
> continue-on-failure |  | boolean optional | This input element is useful when multiple qos-workload objects match a given query. If set to true, the API will continue deleting the next matching qos-workload even when the deletion of a previous qos-workload fails. If set to false, the API will return on the first failure. Default: false
> max-failure-count | [1..2^32-1] | integer optional | When allowing failures ('continue-on-failure' is set to true), then this input element may be provided to limit the number of failed deletions before the server gives up and returns. If set, the API will continue deleting the next matching qos-workload even when the deletion of a previous matching qos-workload fails, and do so until the total number of objects failed to be deleted reaches the maximum specified. If set to the maximum or not provided, then there will be no limit on the number of failed deletions. Only applicable if 'continue-on-failure' is set to true. Default: 2^32-1
> max-records | [1..2^32-1] | integer optional | The maximum number of qos-workload objects to delete in this call. Default: 20
> query |  | qos-workload-info | If deleting a specific qos-workload, this input element must specify all keys. If deleting multiple qos-workload objects based on query, this input element must specify a query.
> return-failure-list |  | boolean optional | If set to true, the API will return the list of qos-workload objects (just keys) that were not deleted due to some error. If set to false, the list of qos-workload objects not deleted will not be returned. Default: true
> return-success-list |  | boolean optional | If set to true, the API will return the list of qos-workload objects (just keys) that were successfully deleted. If set to false, the list of qos-workload objects deleted will not be returned. Default: true
> tag |  | string optional | Specify the tag from the last call. It is usually not specified for the first call. For subsequent calls, copy values from the next-tag obtained from the previous call.
> Output Name | Range | Type | Description
> failure-list |  | qos-workload-delete-iter-info[] optional | Information about qos-workload objects that were not deleted due to some error. This element will be returned only if input element 'return-failure-list' is true.
> next-tag |  | string optional | Tag for the next call. Not present when there are no more matching qos-workload objects to be deleted.
> num-failed | [0..2^32-1] | integer optional | Number of qos-workload objects that matched the query, but were not deleted due to some error.
> num-succeeded | [0..2^32-1] | integer optional | The number of qos-workload objects that matched the query and were successfully deleted.
> success-list |  | qos-workload-delete-iter-info[] optional | The qos-workload objects that were successfully deleted. This element will be returned only if input element 'return-success-list' is true

> Errno | Description
> EINTERNALERROR |  |

qos-workload-get | [top]

> Get the attributes of a workload.

> Input Name | Range | Type | Description
> desired-attributes |  | qos-workload-info optional | Specify the attributes that should be returned. If not present, all attributes for which information is available will be returned. If present, only the desired attributes for which information is available will be returned.
> workload-name |  | string | User visible name of QoS workload.
> Output Name | Range | Type | Description
> attributes |  | qos-workload-info | The attributes of the qos-workload.

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-workload-get-iter | [top]

> Iterate over list of workloads.

> Input Name | Range | Type | Description
> desired-attributes |  | qos-workload-info optional | Specify the attributes that should be returned. If not present, all attributes for which information is available will be returned. If present, only the desired attributes for which information is available will be returned.
> max-records | [1..2^32-1] | integer optional | The maximum number of records to return in this call. Default: 20
> query |  | qos-workload-info optional | A query that specifies which objects to return. A query could be specified on any number of attributes in the qos-workload object. All qos-workload objects matching this query up to 'max-records' will be returned.
> tag |  | string optional | Specify the tag from the last call. It is usually not specified for the first call. For subsequent calls, copy values from the 'next-tag' obtained from the previous call.
> Output Name | Range | Type | Description
> attributes-list |  | qos-workload-info[] optional | The list of attributes of qos-workload objects.
> next-tag |  | string optional | Tag for the next call. Not present when there are no more qos-workload objects to return.
> num-records | [0..2^32-1] | integer | The number of records returned in this call.

> Errno | Description
> EINTERNALERROR |  |

qos-workload-modify | [top]

> Modify an existing workload. This may be used to rename the workload, modify the workload's ID, its class, or its category.

> Input Name | Range | Type | Description
> read-ahead |  | string optional | Name for a read-ahead tunable policy.
> workload-name |  | string | User visible name of QoS workload.

> Errno | Description
> EOBJECTNOTFOUND |  |
> EINTERNALERROR |  |

qos-workload-modify-iter | [top]

> Modify multiple workloads

> Input Name | Range | Type | Description
> attributes |  | qos-workload-info | Specify at least one modifiable element. Do not specify any other element.
> continue-on-failure |  | boolean optional | This input element is useful when multiple qos-workload objects match a given query. If set to true, the API will continue modifying the next matching qos-workload even when modification of a previous qos-workload fails. If set to false, the API will return on the first failure. Default: false
> max-failure-count | [1..2^32-1] | integer optional | When allowing failures ('continue-on-failure' is set to true), then this input element may be provided to limit the number of failed modify operations before the server gives up and returns. If set, the API will continue modifying the next matching qos-workload even when the modification of a previous matching qos-workload fails, and do so until the total number of objects failed to be modified reaches the maximum specified. If set to the maximum or not provided, then there will be no limit on the number of failed modify operations. Only applicable if 'continue-on-failure' is set to true. Default: 2^32-1
> max-records | [1..2^32-1] | integer optional | The maximum number of objects to be modified in this call. Default: 20
> query |  | qos-workload-info | If modifying a specific qos-workload, this input element must specify all keys. If modifying qos-workload objects based on query, this input element must specify a query.
> return-failure-list |  | boolean optional | If set to true, the API will return the list of qos-workload objects (just keys) that were not modified due to some error. If set to false, the list of qos-workload objects not modified will not be returned. Default: true
> return-success-list |  | boolean optional | If set to true, the API will return the list of qos-workload objects (just keys) that were successfully updated. If set to false, the list of qos-workload objects modified will not be returned. Default: true
> tag |  | string optional | Specify the tag from the last call. It is usually not specified for the first call. For subsequent calls, copy values from the 'next-tag' obtained from the previous call.
> Output Name | Range | Type | Description
> failure-list |  | qos-workload-modify-iter-info[] optional | Information about qos-workload objects that were not modified due to some error. This element will be returned only if input element 'return-failure-list' is true.
> next-tag |  | string optional | Tag for the next call. Not present when there are no more matching qos-workload objects to be modified.
> num-failed | [0..2^32-1] | integer optional | Number of qos-workload objects that matched the query, but were not modified due to some error.
> num-succeeded | [0..2^32-1] | integer optional | The number of qos-workload objects that matched the query and were successfully updated.
> success-list |  | qos-workload-modify-iter-info[] optional | The qos-workload objects that were successfully updated. This element will be returned only if input element 'return-success-list' is true

> Errno | Description
> EINTERNALERROR |  |

Element definition: qos-class | [top]

> preset|user-defined|system-defined Possible values: "preset" - Preset, "user_defined" - User Defined, "system_defined" - System Defined

> [none]

Element definition: qos-policy-group-delete-iter-info | [top]

> Information about the deletion operation that was attempted/performed against qos-policy-group object.

> Name | Range | Type | Description
> error-code | [0..2^32-1] | integer optional | Error code, if the deletion operation caused an error.
> error-message |  | string optional | Error description, if the operation caused an error.
> qos-policy-group-key |  | qos-policy-group-info | The keys for the qos-policy-group object to which the deletion applies.

Element definition: qos-policy-group-info | [top]

> Information about a QoS policy group When returned as part of the output, all elements of this typedef are reported, unless limited by a set of desired attributes specified by the caller. When used as input to specify desired attributes to return, omitting a given element indicates that it shall not be returned in the output. In contrast, by providing an element (even with no value) the caller ensures that a value for that element will be returned, given that the value can be retrieved. When used as input to specify queries, any element can be omitted in which case the resulting set of objects is not constrained by any specific value of that attribute.

> Name | Range | Type | Description
> max-throughput |  | qos-tput optional | Maximum throughput defined by this policy. It is specified in terms of IOPS or MB/s, and the range is zero to infinity. The values entered here are case-insensitive, and the units are base ten. There should be no space between the number and the units. The default value for max-throughput is infinity. The default unit is IOPS. Two reserved keywords, 'none' and 'INF', are available for the situation that requires removal of a value, and the situation that needs to specify the maximum available value. Examples of valid specifications are: 100B/s, 10KB/s, 1gb/s, 500MB/s, 1tb/s, and 100iops. Attributes: optional-for-create, modifiable
> pgid | [0..2^32-1] | integer optional | The ID used to identify the policy group. Attributes: non-creatable, non-modifiable
> policy-group |  | string optional | Name of the policy group. Policy group names must be unique and are restricted to 128 alphanumeric characters, '-', and '_', and must start with an alphanumeric character (a-z, A-Z, or 0-9). Attributes: key, required-for-create, non-modifiable
> policy-group-class |  | qos-class optional | Class for the policy group. Attributes: non-creatable, non-modifiable Possible values: "preset" - Preset, "user_defined" - User Defined, "system_defined" - System Defined
> uuid |  | uuid optional | Universally unique identifier for the QoS policy group. Attributes: non-creatable, non-modifiable
> vserver |  | vserver-name optional | The Data Vserver to which the policy group belongs. Attributes: required-for-create, non-modifiable

Element definition: qos-policy-group-modify-iter-info | [top]

> Information about the modify operation that was attempted/performed against qos-policy-group object.

> Name | Range | Type | Description
> error-code | [0..2^32-1] | integer optional | Error code, if the modify operation caused an error.
> error-message |  | string optional | Error description, if the modify operation caused an error.
> qos-policy-group-key |  | qos-policy-group-info | The keys for the qos-policy-group object to which the modify operation applies.

Element definition: qos-settings-archived-workload-info | [top]

> Archival settings for QoS workload Objects. When returned as part of the output, all elements of this typedef are reported, unless limited by a set of desired attributes specified by the caller. When used as input to specify desired attributes to return, omitting a given element indicates that it shall not be returned in the output. In contrast, by providing an element (even with no value) the caller ensures that a value for that element will be returned, given that the value can be retrieved. When used as input to specify queries, any element can be omitted in which case the resulting set of objects is not constrained by any specific value of that attribute.

> Name | Range | Type | Description
> max-workloads | [0..15000] | integer optional | Maximum Number of Workloads to be Archived Attributes: non-creatable, modifiable

Element definition: qos-settings-control-info | [top]

> Information about QoS control settings. When returned as part of the output, all elements of this typedef are reported, unless limited by a set of desired attributes specified by the caller. When used as input to specify desired attributes to return, omitting a given element indicates that it shall not be returned in the output. In contrast, by providing an element (even with no value) the caller ensures that a value for that element will be returned, given that the value can be retrieved. When used as input to specify queries, any element can be omitted in which case the resulting set of objects is not constrained by any specific value of that attribute.

> Name | Range | Type | Description
> enforcement |  | boolean optional | Cluster-wide QoS enforcement Attributes: non-creatable, modifiable
> ratebucket-rebalance |  | boolean optional | Manage QoS ratebucket budgets across the cluster Attributes: non-creatable, modifiable

Element definition: qos-settings-read-ahead-destroy-iter-info | [top]

> Information about the deletion operation that was attempted/performed against qos-settings-read-ahead object.

> Name | Range | Type | Description
> error-code | [0..2^32-1] | integer optional | Error code, if the deletion operation caused an error.
> error-message |  | string optional | Error description, if the operation caused an error.
> qos-settings-read-ahead-key |  | qos-settings-read-ahead-info | The keys for the qos-settings-read-ahead object to which the deletion applies.

Element definition: qos-settings-read-ahead-info | [top]

> QoS read-ahead setting typedef When returned as part of the output, all elements of this typedef are reported, unless limited by a set of desired attributes specified by the caller. When used as input to specify desired attributes to return, omitting a given element indicates that it shall not be returned in the output. In contrast, by providing an element (even with no value) the caller ensures that a value for that element will be returned, given that the value can be retrieved. When used as input to specify queries, any element can be omitted in which case the resulting set of objects is not constrained by any specific value of that attribute.

> Name | Range | Type | Description
> align-blocks | [8..256] | integer optional | Block alignment Attributes: optional-for-create, modifiable
> default |  | boolean optional | Specifies whether this is the default readahead setting Attributes: optional-for-create, modifiable
> disk-response-factor | [1..10] | integer optional | Disk response time factor Attributes: optional-for-create, modifiable
> disk-response-weight | [0..100] | integer optional | Weight for disk response time aging (%) Attributes: optional-for-create, modifiable
> early-count | [0..1024] | integer optional | Number of IO operations cautiously predicted Attributes: optional-for-create, modifiable
> force-dump |  | boolean optional | Force DUMP-style readahead Attributes: optional-for-create, modifiable
> force-full |  | boolean optional | Force full-file readahead Attributes: optional-for-create, modifiable
> force-none |  | boolean optional | Disable readahead Attributes: optional-for-create, modifiable
> interarrival-weight | [0..100] | integer optional | Weight for interarrival time aging (%) Attributes: optional-for-create, modifiable
> jitter | [0..100] | integer optional | Threshold for detecting jitter (%) Attributes: optional-for-create, modifiable
> max-blocks | [64..1024] | integer optional | Maximum blocks to speculate Attributes: optional-for-create, modifiable
> max-deadline | [100000..5000000] | integer optional | Maximum deadline Offset (ms) Attributes: optional-for-create, modifiable
> max-disk-response-time | [100..50000] | integer optional | Maximum disk response time (ms) Attributes: optional-for-create, modifiable
> max-gap | [512..4096] | integer optional | Maximum speculative blocks outstanding Attributes: optional-for-create, modifiable
> max-range | [1024..40960] | integer optional | Maximum range used when aging streams (Blocks) Attributes: optional-for-create, modifiable
> max-retire-time | [10000..10000000] | integer optional | Maximum Time Before a Stream is Retired (us) Attributes: optional-for-create, modifiable
> metadata-blocks | [0..2048] | integer optional | Minimum blocks for which metadata is predicted Attributes: optional-for-create, modifiable
> min-blocks | [64..1024] | integer optional | Minimum blocks to speculate Attributes: optional-for-create, modifiable
> min-disk-response-time | [100..50000] | integer optional | Minimum disk response time (ms) Attributes: optional-for-create, modifiable
> min-range | [1024..40960] | integer optional | Minimum range used when aging streams (Blocks) Attributes: optional-for-create, modifiable
> min-retire-time | [10000..10000000] | integer optional | Minimum Time Before a Stream is Retired (us) Attributes: optional-for-create, modifiable
> overshoot | [0..500] | integer optional | Allowable overshoot (%) Attributes: optional-for-create, modifiable
> read-ahead-class |  | qos-class optional | Readahead setting class Attributes: optional-for-create, non-modifiable Possible values: "preset" - Preset, "user_defined" - User Defined, "system_defined" - System Defined
> read-ahead-setting-name |  | string optional | Name of QoS Readahead Setting. Attributes: key, required-for-create, non-modifiable
> smallfile-blocks | [0..128] | integer optional | Maximum blocks for small-file handling Attributes: optional-for-create, modifiable
> use-async |  | boolean optional | Use asynchronous speculation Attributes: optional-for-create, modifiable
> use-feedback |  | boolean optional | Provide cache-miss feedback Attributes: optional-for-create, modifiable
> use-histogram |  | boolean optional | Use Histogram-based predictions Attributes: optional-for-create, modifiable
> use-timing |  | boolean optional | Use timing algorithms Attributes: optional-for-create, modifiable

Element definition: qos-settings-read-ahead-modify-iter-info | [top]

> Information about the modify operation that was attempted/performed against qos-settings-read-ahead object.

> Name | Range | Type | Description
> error-code | [0..2^32-1] | integer optional | Error code, if the modify operation caused an error.
> error-message |  | string optional | Error description, if the modify operation caused an error.
> qos-settings-read-ahead-key |  | qos-settings-read-ahead-info | The keys for the qos-settings-read-ahead object to which the modify operation applies.

Element definition: qos-tput | [top]

> QoS throughput type

> [none]

Element definition: qos-workload-delete-iter-info | [top]

> Information about the deletion operation that was attempted/performed against qos-workload object.

> Name | Range | Type | Description
> error-code | [0..2^32-1] | integer optional | Error code, if the deletion operation caused an error.
> error-message |  | string optional | Error description, if the operation caused an error.
> qos-workload-key |  | qos-workload-info | The keys for the qos-workload object to which the deletion applies.

Element definition: qos-workload-info | [top]

> Information about a QoS workload When returned as part of the output, all elements of this typedef are reported, unless limited by a set of desired attributes specified by the caller. When used as input to specify desired attributes to return, omitting a given element indicates that it shall not be returned in the output. In contrast, by providing an element (even with no value) the caller ensures that a value for that element will be returned, given that the value can be retrieved. When used as input to specify queries, any element can be omitted in which case the resulting set of objects is not constrained by any specific value of that attribute.

> Name | Range | Type | Description
> category |  | string optional | Category used to identify the workload. Attributes: non-creatable, non-modifiable
> file |  | string optional | Name for a file workload. Attributes: optional-for-create, non-modifiable
> lun |  | string optional | Name for a lun workload. Attributes: optional-for-create, non-modifiable
> policy-group |  | string optional | Name for a QoS policy group. Attributes: non-creatable, non-modifiable
> qtree |  | string optional | Name for a qtree workload. Attributes: optional-for-create, non-modifiable
> read-ahead |  | string optional | Name for a read-ahead tunable policy. Attributes: optional-for-create, modifiable
> volume |  | string optional | Name for a volume workload. Attributes: optional-for-create, non-modifiable
> vserver |  | string optional | Name for a vserver workload. Attributes: optional-for-create, non-modifiable
> wid | [0..2^32-1] | integer optional | Internal identifier for workload. Attributes: non-creatable, non-modifiable
> workload-class |  | qos-class optional | Class for the workload. Attributes: non-creatable, non-modifiable Possible values: "preset" - Preset, "user_defined" - User Defined, "system_defined" - System Defined
> workload-name |  | string optional | User visible name of QoS workload. Attributes: key, required-for-create, non-modifiable
> workload-uuid |  | uuid optional | Universally unique identifier for the QoS workload. Attributes: non-creatable, non-modifiable

Element definition: qos-workload-modify-iter-info | [top]

> Information about the modify operation that was attempted/performed against qos-workload object.

> Name | Range | Type | Description
> error-code | [0..2^32-1] | integer optional | Error code, if the modify operation caused an error.
> error-message |  | string optional | Error description, if the modify operation caused an error.
> qos-workload-key |  | qos-workload-info | The keys for the qos-workload object to which the modify operation applies.

Element definition: vserver-name | [top]

> The name of the Vserver.

> [none]

Element definition: qos-class | [top]

> preset|user-defined|system-defined Possible values: "preset" - Preset, "user_defined" - User Defined, "system_defined" - System Defined

> [none]

Element definition: qos-policy-group-info | [top]

> Information about a QoS policy group When returned as part of the output, all elements of this typedef are reported, unless limited by a set of desired attributes specified by the caller. When used as input to specify desired attributes to return, omitting a given element indicates that it shall not be returned in the output. In contrast, by providing an element (even with no value) the caller ensures that a value for that element will be returned, given that the value can be retrieved. When used as input to specify queries, any element can be omitted in which case the resulting set of objects is not constrained by any specific value of that attribute.

> Name | Range | Type | Description
> max-throughput |  | qos-tput optional | Maximum throughput defined by this policy. It is specified in terms of IOPS or MB/s, and the range is zero to infinity. The values entered here are case-insensitive, and the units are base ten. There should be no space between the number and the units. The default value for max-throughput is infinity. The default unit is IOPS. Two reserved keywords, 'none' and 'INF', are available for the situation that requires removal of a value, and the situation that needs to specify the maximum available value. Examples of valid specifications are: 100B/s, 10KB/s, 1gb/s, 500MB/s, 1tb/s, and 100iops. Attributes: optional-for-create, modifiable
> pgid | [0..2^32-1] | integer optional | The ID used to identify the policy group. Attributes: non-creatable, non-modifiable
> policy-group |  | string optional | Name of the policy group. Policy group names must be unique and are restricted to 128 alphanumeric characters, '-', and '_', and must start with an alphanumeric character (a-z, A-Z, or 0-9). Attributes: key, required-for-create, non-modifiable
> policy-group-class |  | qos-class optional | Class for the policy group. Attributes: non-creatable, non-modifiable Possible values: "preset" - Preset, "user_defined" - User Defined, "system_defined" - System Defined
> uuid |  | uuid optional | Universally unique identifier for the QoS policy group. Attributes: non-creatable, non-modifiable
> vserver |  | vserver-name optional | The Data Vserver to which the policy group belongs. Attributes: required-for-create, non-modifiable

Element definition: qos-settings-read-ahead-info | [top]

> QoS read-ahead setting typedef When returned as part of the output, all elements of this typedef are reported, unless limited by a set of desired attributes specified by the caller. When used as input to specify desired attributes to return, omitting a given element indicates that it shall not be returned in the output. In contrast, by providing an element (even with no value) the caller ensures that a value for that element will be returned, given that the value can be retrieved. When used as input to specify queries, any element can be omitted in which case the resulting set of objects is not constrained by any specific value of that attribute.

> Name | Range | Type | Description
> align-blocks | [8..256] | integer optional | Block alignment Attributes: optional-for-create, modifiable
> default |  | boolean optional | Specifies whether this is the default readahead setting Attributes: optional-for-create, modifiable
> disk-response-factor | [1..10] | integer optional | Disk response time factor Attributes: optional-for-create, modifiable
> disk-response-weight | [0..100] | integer optional | Weight for disk response time aging (%) Attributes: optional-for-create, modifiable
> early-count | [0..1024] | integer optional | Number of IO operations cautiously predicted Attributes: optional-for-create, modifiable
> force-dump |  | boolean optional | Force DUMP-style readahead Attributes: optional-for-create, modifiable
> force-full |  | boolean optional | Force full-file readahead Attributes: optional-for-create, modifiable
> force-none |  | boolean optional | Disable readahead Attributes: optional-for-create, modifiable
> interarrival-weight | [0..100] | integer optional | Weight for interarrival time aging (%) Attributes: optional-for-create, modifiable
> jitter | [0..100] | integer optional | Threshold for detecting jitter (%) Attributes: optional-for-create, modifiable
> max-blocks | [64..1024] | integer optional | Maximum blocks to speculate Attributes: optional-for-create, modifiable
> max-deadline | [100000..5000000] | integer optional | Maximum deadline Offset (ms) Attributes: optional-for-create, modifiable
> max-disk-response-time | [100..50000] | integer optional | Maximum disk response time (ms) Attributes: optional-for-create, modifiable
> max-gap | [512..4096] | integer optional | Maximum speculative blocks outstanding Attributes: optional-for-create, modifiable
> max-range | [1024..40960] | integer optional | Maximum range used when aging streams (Blocks) Attributes: optional-for-create, modifiable
> max-retire-time | [10000..10000000] | integer optional | Maximum Time Before a Stream is Retired (us) Attributes: optional-for-create, modifiable
> metadata-blocks | [0..2048] | integer optional | Minimum blocks for which metadata is predicted Attributes: optional-for-create, modifiable
> min-blocks | [64..1024] | integer optional | Minimum blocks to speculate Attributes: optional-for-create, modifiable
> min-disk-response-time | [100..50000] | integer optional | Minimum disk response time (ms) Attributes: optional-for-create, modifiable
> min-range | [1024..40960] | integer optional | Minimum range used when aging streams (Blocks) Attributes: optional-for-create, modifiable
> min-retire-time | [10000..10000000] | integer optional | Minimum Time Before a Stream is Retired (us) Attributes: optional-for-create, modifiable
> overshoot | [0..500] | integer optional | Allowable overshoot (%) Attributes: optional-for-create, modifiable
> read-ahead-class |  | qos-class optional | Readahead setting class Attributes: optional-for-create, non-modifiable Possible values: "preset" - Preset, "user_defined" - User Defined, "system_defined" - System Defined
> read-ahead-setting-name |  | string optional | Name of QoS Readahead Setting. Attributes: key, required-for-create, non-modifiable
> smallfile-blocks | [0..128] | integer optional | Maximum blocks for small-file handling Attributes: optional-for-create, modifiable
> use-async |  | boolean optional | Use asynchronous speculation Attributes: optional-for-create, modifiable
> use-feedback |  | boolean optional | Provide cache-miss feedback Attributes: optional-for-create, modifiable
> use-histogram |  | boolean optional | Use Histogram-based predictions Attributes: optional-for-create, modifiable
> use-timing |  | boolean optional | Use timing algorithms Attributes: optional-for-create, modifiable

Element definition: qos-tput | [top]

> QoS throughput type

> [none]

Element definition: qos-workload-info | [top]

> Information about a QoS workload When returned as part of the output, all elements of this typedef are reported, unless limited by a set of desired attributes specified by the caller. When used as input to specify desired attributes to return, omitting a given element indicates that it shall not be returned in the output. In contrast, by providing an element (even with no value) the caller ensures that a value for that element will be returned, given that the value can be retrieved. When used as input to specify queries, any element can be omitted in which case the resulting set of objects is not constrained by any specific value of that attribute.

> Name | Range | Type | Description
> category |  | string optional | Category used to identify the workload. Attributes: non-creatable, non-modifiable
> file |  | string optional | Name for a file workload. Attributes: optional-for-create, non-modifiable
> lun |  | string optional | Name for a lun workload. Attributes: optional-for-create, non-modifiable
> policy-group |  | string optional | Name for a QoS policy group. Attributes: non-creatable, non-modifiable
> qtree |  | string optional | Name for a qtree workload. Attributes: optional-for-create, non-modifiable
> read-ahead |  | string optional | Name for a read-ahead tunable policy. Attributes: optional-for-create, modifiable
> volume |  | string optional | Name for a volume workload. Attributes: optional-for-create, non-modifiable
> vserver |  | string optional | Name for a vserver workload. Attributes: optional-for-create, non-modifiable
> wid | [0..2^32-1] | integer optional | Internal identifier for workload. Attributes: non-creatable, non-modifiable
> workload-class |  | qos-class optional | Class for the workload. Attributes: non-creatable, non-modifiable Possible values: "preset" - Preset, "user_defined" - User Defined, "system_defined" - System Defined
> workload-name |  | string optional | User visible name of QoS workload. Attributes: key, required-for-create, non-modifiable
> workload-uuid |  | uuid optional | Universally unique identifier for the QoS workload. Attributes: non-creatable, non-modifiable

Element definition: uuid | [top]

> The 128-bit universally-unique identifier (UUID). UUIDs are formatted as 36-character strings. These strings are composed of 32 hexadecimal characters broken up into five groupings separated by '-'s.The first grouping has 8 hex characters, the second through fourth groupings have four hex characters each, and the fifth and final grouping has 12 hex characters. Note that a leading '0x' is not used.

> [none]

Element definition: vserver-name | [top]

> The name of the Vserver.

> [none]

Element definition: qos-class | [top]

> preset|user-defined|system-defined Possible values: "preset" - Preset, "user_defined" - User Defined, "system_defined" - System Defined

> [none]